<?php
function smarty_block_mtqueryloop( $args, $content, &$ctx, &$repeat ) {
    $localvars = array( 'vars', '_counter', '__max' );
    $to_encoding = $ctx->mt->config( 'PublishCharset' );
    $to_encoding or $to_encoding = 'UTF-8';
    $param = getenv( 'REDIRECT_QUERY_STRING' );
    if ( preg_match( '/IIS/', $_SERVER[ 'SERVER_SOFTWARE' ] ) ) {
        $param = $_SERVER[ 'QUERY_STRING' ];
    }
    $key = $args[ 'key' ];
    $glue = $args[ 'glue' ];
    if (! isset( $content ) ) {
        $ctx->localize( $localvars );
        $counter = 0;
    } else {
        $counter = $ctx->stash( '_counter' );
    }
    $vars = $ctx->stash( 'vars' );
    if (! isset( $vars ) ) {
        $vars = $_REQUEST[ $key ];
        $max = count( $vars );
        $ctx->stash( '__max', $max );
        $ctx->stash( 'vars', $vars );
    } else {
        $counter = $ctx->stash( '_counter' );
        $max = $ctx->stash( '__max' );
    }
    if ( $counter < $max ) {
        $count = $counter + 1;
        $value = $vars[ $counter ];
        if ( ( $glue ) && ( $count != $max ) ) {
            $value .= $glue;
        }
        $from_encoding = mb_detect_encoding( $value, 'UTF-8,EUC-JP,SJIS,JIS' );
        $value = mb_convert_encoding( $value, $to_encoding, $from_encoding );
        $ctx->__stash[ 'vars' ][ $key ] = $value;
        $ctx->__stash[ 'vars' ][ '__counter__' ] = $count;
        $ctx->__stash[ 'vars' ][ '__odd__' ]  = ( $count % 2 ) == 1;
        $ctx->__stash[ 'vars' ][ '__even__' ] = ( $count % 2 ) == 0;
        $ctx->__stash[ 'vars' ][ '__first__' ] = $count == 1;
        $ctx->__stash[ 'vars' ][ '__last__' ] = ( $count == $max );
        $ctx->stash( '_counter', $count );
        $repeat = true;
    } else {
        $ctx->restore( $localvars );
        $repeat = false;
    }
    return $content;
}
?>